package com.winhc.widget;

import android.graphics.Color;
import android.os.Build;
import android.view.WindowManager;

import com.winhc.widget.util.MySystemBarUtils;
import com.winhc.widget.util.SystemBarUtils;

/**
 * Create by LZ at 2021/10/12
 */
public abstract class BaseDialogActivity<T extends IPresenter> extends BaseActivity<T> {

    @Override
    protected void defaultAnimator() {
        overridePendingTransition(R.anim.slide_bottom_in, R.anim.slide_bottom_no);
    }

    protected void initSystemBar() {
        //设置电池栏为透明色,大部分activity都需要,不需要的时候直接重写initWindow方法
        SystemBarUtils.setTranslucentStatusBar(this, Color.TRANSPARENT, false);
        SystemBarUtils.myStatusBar(this, Color.TRANSPARENT, false);

        MySystemBarUtils.setStatusTextColor(true, this);
        if (Build.VERSION.SDK_INT >= 21) {
            getWindow().setStatusBarColor(Color.TRANSPARENT);
        } else if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.KITKAT) {
            getWindow().addFlags(WindowManager.LayoutParams.FLAG_TRANSLUCENT_STATUS);
        }
    }

    @Override
    public void finish() {
        overridePendingTransition(R.anim.slide_bottom_no, R.anim.slide_bottom_out);
    }
}
