package com.winhc.widget;

import android.os.Bundle;
import android.support.v7.widget.RecyclerView;
import android.view.View;

/**
 * Create by LZ at 2021/10/13
 */
public abstract class BaseRecyclerFragment<T extends IPresenter> extends BaseFragment<T> {
    RecyclerView recyclerView;

    @Override
    protected int initContentView() {
        return R.layout.fragment_recycler_view;
    }

    @Override
    protected void onInflated(View mContentView, Bundle savedInstanceState) {
        recyclerView = mContentView.findViewById(R.id.base_recycler_view);
    }

    @Override
    protected void initData() {
        super.initData();
        if (recyclerView == null) {
            throw new IllegalArgumentException("必须包含id 为 core_recycler_view 的RecyclerView");
        }
        recyclerView.setLayoutManager(getLayoutManager());
        recyclerView.setAdapter(getAdapter());
    }

    protected abstract RecyclerView.Adapter getAdapter();

    protected abstract RecyclerView.LayoutManager getLayoutManager();
}
