package com.winhc.business;

import android.app.Activity;
import android.content.Context;
import android.content.Intent;
import android.os.Build;
import android.os.Bundle;
import android.text.TextUtils;

import com.google.gson.reflect.TypeToken;
import com.winhc.business.builder.CommonDialog;
import com.winhc.business.model.UserLawyerCertifyBean;
import com.winhc.business.utils.SensorDataEventUtils;
import com.winhc.business.utils.StringUtils;
import com.winhc.widget.util.MMLog;
import com.winhc.widget.util.StringUtil;

import java.util.ArrayList;
import java.util.List;

/**
 * Author by 10211, Email 1021190889@qq.com, Date on 2020/5/20.
 * describe:
 *
 * @author 10211
 */
public class WinhcSetting {
    public static String[] FILE_PERMISSIONS = new String[]{
            android.Manifest.permission.WRITE_EXTERNAL_STORAGE,
            android.Manifest.permission.READ_EXTERNAL_STORAGE
    };
    public static final String WINHC_PHONE = "4000-697-267";
    public static final String LAY_TYPE = "2";
    //人员图片前缀
    public static final String APP_LEGAL_AVATOR = "https://winhc.oss-cn-shanghai.aliyuncs.com/bigdata/humanLogo/";
    //公司图片前缀
    public static final String APP_COMPANY_AVATOR = "https://winhc.oss-cn-shanghai.aliyuncs.com/bigdata/companyLogo/";
    //公司VIP
    public static final String APP_VIP = "https://winhc.oss-cn-shanghai.aliyuncs.com/app/";
    //合同模板https://winhc.oss-cn-shanghai.aliyuncs.com/app/contractTemplae/1.png
    //分析报告 https://winhc.oss-cn-shanghai.aliyuncs.com/app/analysisReport/0.png
    //使用权益 https://winhc.oss-cn-shanghai.aliyuncs.com/app/vip/0.png
    public static String currentAcyName = "";
    public static List<String> yanQuanList = new ArrayList<>();

    public static String getCurrentAcyName() {
        if ("BuyVipDialogAcy".equals(currentAcyName)) {
            return "winhc://appvip:7088/" + currentAcyName;
        } else if ("VIPCenterActivity".equals(currentAcyName)) {
            return "winhc://appvip:7099/" + currentAcyName;
        }
        return currentAcyName;
    }
    public static int getVersionCode() {
        return WinhcSharedPreferences.getVersionCode();
    }

    public static String getVersionName() {
        return WinhcSharedPreferences.getVersionName();
    }
    public static String getAppChannel() {
        return WinhcSharedPreferences.getAppChannel();
    }
    public static void setCurrentAcyName(String newAcyName) {
        currentAcyName = newAcyName;
    }

    public static List<String> getTiYanQuanList() {
        return yanQuanList;
    }

    public static void setTiYanQuanList(List<String> tiYanQuanList) {
        yanQuanList = tiYanQuanList;
    }

    /**
     * 获取设备品牌
     *
     * @return
     */
    public static String getOsBrand() {
        return Build.BRAND;
    }

    /**
     * 获取系统版本字符串。如4.1.2 或2.2 或2.3等
     *
     * @return
     */
    public static String getOsVersion() {
        return Build.VERSION.RELEASE;
    }

    public static boolean isVip() {
        UserLawyerCertifyBean userLawyerCertifyBean = WinhcSharedPreferences.getBean(WinhcSharedPreferences.KEY_USER_LAWYER_CERTIFY, new TypeToken<UserLawyerCertifyBean>() {
        }.getType());
        return null != userLawyerCertifyBean && !TextUtils.isEmpty(userLawyerCertifyBean.vipSign) && !"1".equals(userLawyerCertifyBean.vipSign);
    }

    //是否入驻
    public static boolean isSettle() {
        UserLawyerCertifyBean userLawyerCertifyBean = WinhcSharedPreferences.getBean(WinhcSharedPreferences.KEY_USER_LAWYER_CERTIFY, new TypeToken<UserLawyerCertifyBean>() {
        }.getType());
        return null != userLawyerCertifyBean && !"0".equals(userLawyerCertifyBean.settleStatus);
    }

    public static String getIdentity() {
        //1、商务，2、律师，3、法务，4、其他法律人
        return WinhcSharedPreferences.getString(WinhcSharedPreferences.KEY_IDENTITY, "1");
    }

    public static String getWxBindDate() {
        return WinhcSharedPreferences.getString(WinhcSharedPreferences.WX_BIND_DATE, "");
    }

    public static String getLbsInfo() {
        return WinhcSharedPreferences.getString(WinhcSharedPreferences.KEY_LBS_VALUE, "上海市");
    }

    public static String getLbsInfo_() {
        return WinhcSharedPreferences.getString(WinhcSharedPreferences.KEY_LBS_PROVINCE_VALUE, "上海");
    }

    public static String getLbsCodeInfo() {
        return WinhcSharedPreferences.getString(WinhcSharedPreferences.KEY_LBS_CODE_VALUE, "310000");
    }

    //获取头像相关信息
    public static String getUserAvatarSomeInfo() {
        String avatar = AccountManager.getInstance().getAccount().avatar;
        try {
            return avatar.substring(avatar.indexOf("YHC/") + 4);
        } catch (Exception e) {
            MMLog.e(e.getMessage());
            return "";
        }
    }

    //获取身份信息中文
    public static String getIdentityString(String identity) {
        if (StringUtil.isEmpty(identity)) return "";
        switch (identity) {
            case "1":
                return "普通用户";
            case "2":
                return "律师";
            case "3":
                return "法务";
            case "4":
                return "其他法律人";
            default:
                return "";
        }
    }

    //获取身份信息中文
    public static String getLawyerString(int subLawyerType) {
        switch (subLawyerType) {
            case 2:
                return "实习律师";
            case 3:
                return "公职律师";
            case 4:
                return "基层法律服务工作者";
            default:
                return "律师";
        }
    }

    //律师或者其他法律人
    public static boolean isLawOrOrtherLaw() {
        String identity = WinhcSharedPreferences.getString(WinhcSharedPreferences.KEY_IDENTITY, "1");
        return identity.equals("2") || identity.equals("4");
    }

    //律师
    public static boolean isLawer() {
        String identity = WinhcSharedPreferences.getString(WinhcSharedPreferences.KEY_IDENTITY, "1");
        return identity.equals("2");
    }

    public static boolean isCertified() {
        UserLawyerCertifyBean userLawyerCertifyBean = WinhcSharedPreferences.getBean(WinhcSharedPreferences.KEY_USER_LAWYER_CERTIFY, new TypeToken<UserLawyerCertifyBean>() {
        }.getType());
        return null != userLawyerCertifyBean && !TextUtils.isEmpty(userLawyerCertifyBean.lawyerStatus) && "2".equals(userLawyerCertifyBean.lawyerStatus);
    }

    //是否是认证律师
    public static boolean isCertifiedLawyer() {
        UserLawyerCertifyBean userLawyerCertifyBean = WinhcSharedPreferences.getBean(WinhcSharedPreferences.KEY_USER_LAWYER_CERTIFY, new TypeToken<UserLawyerCertifyBean>() {
        }.getType());
        return null != userLawyerCertifyBean && "2".equals(userLawyerCertifyBean.lawyerStatus) && "2".equals(userLawyerCertifyBean.getIdentity());
    }

    //是否认证中
    public static boolean isCertifing() {
        UserLawyerCertifyBean userLawyerCertifyBean = WinhcSharedPreferences.getBean(WinhcSharedPreferences.KEY_USER_LAWYER_CERTIFY, new TypeToken<UserLawyerCertifyBean>() {
        }.getType());
        return null != userLawyerCertifyBean && "1".equals(userLawyerCertifyBean.lawyerStatus);
    }

    /**
     * 获取当前保存的用户信息 内容信息见{@link UserLawyerCertifyBean}
     *
     * @return
     */
    public static UserLawyerCertifyBean getUserExt() {
        return WinhcSharedPreferences.getBean(WinhcSharedPreferences.KEY_USER_LAWYER_CERTIFY,
                new TypeToken<UserLawyerCertifyBean>() {
                }.getType());
    }

    /**
     * 新认证的用户的跳转
     *
     * @param context    上下文
     * @param ulcb       用户对象数据
     * @param sourceName 埋点来源
     */
    public static void goNewAuth(Context context, Activity authActivity, Activity authNextActivity, UserLawyerCertifyBean ulcb, String sourceName) {
        if (null != context && null != ulcb && "0".equals(StringUtils.checkString(ulcb.lawyerStatus))) {
            if (!StringUtil.isEmpty(sourceName)) {
                SensorDataEventUtils.trackSingleAction(SensorDataEventUtils.LAYER_AUTH, "button_name", sourceName);
            }
            readyGo(context, authActivity, null);
        } else {
            readyGo(context, authNextActivity, null);
        }
    }

    public static boolean isCompany(String name) {
        if (!TextUtils.isEmpty(name) && name.length() > 5) {
            return false;
        } else {
            return false;
        }
    }

    //账款精灵是否显示金额
    public static boolean isHidden() {
        if (AccountManager.getInstance().isLoginSync()) {
            return WinhcSharedPreferences.getBoolean(AccountManager.getInstance().getAccount().mobileNo + "isHidden", false);
        } else {
            return false;
        }
    }

    //账款精灵是否体验模式
    public static boolean ifExperience() {
        return WinhcSharedPreferences.getBoolean("accountExperience", false);
    }

    public static boolean judgeAuthOrSettle(final Context mContext, final Activity authActivity, final Activity authNextActivity, final Activity thirdActivity, final String sourceName) {
        //判断是否认证中
        if (isCertifing()) {
            CommonDialog.showLoginDialog(mContext, "您提交的认证正在审核中，请稍等", "小赢正在加速审核您的认证信息，请耐心等待。", "立即查看", "取消", new CommonDialog.CommonDialogCallback() {
                @Override
                public void onConfirmListener() {
                    goNewAuth(mContext, authActivity, authNextActivity, getUserExt(), sourceName);
                }

                @Override
                public void onCancelListener() {

                }
            });
            return false;
        }
        //判断是否认证了
        if (!isCertified()) {
            if ("3".equals(getIdentity())) {
                //法务
                CommonDialog.showLoginDialog(mContext, "暂未认证，请立即前往认证", "认证成功后即可回答问题", "我再考虑下", "去认证", new CommonDialog.CommonDialogCallback() {
                    @Override
                    public void onConfirmListener() {
                        goNewAuth(mContext, authActivity, authNextActivity, getUserExt(), sourceName);
                    }

                    @Override
                    public void onCancelListener() {

                    }
                });
            } else {
                //律师
                CommonDialog.showLoginDialog(mContext, "暂未认证，请立即前往认证", "认证成功即可获得：海量案源、律师推荐、认证标识别等特权。", "我再考虑下", "去认证", new CommonDialog.CommonDialogCallback() {
                    @Override
                    public void onConfirmListener() {
                        goNewAuth(mContext, authActivity, authNextActivity, getUserExt(), sourceName);
                    }

                    @Override
                    public void onCancelListener() {

                    }
                });
            }
            return false;
        } else {
            if (!isSettle()) {
                if ("3".equals(getIdentity())) {
                    //法务
                    CommonDialog.showLoginDialog(mContext, "完善认证信息", "回答问题前，需完善并重新认证您的法务信息", "我再考虑下", "去认证", new CommonDialog.CommonDialogCallback() {
                        @Override
                        public void onConfirmListener() {
                            goNewAuth(mContext, authActivity, authNextActivity, getUserExt(), sourceName);
                        }

                        @Override
                        public void onCancelListener() {

                        }
                    });
                } else {
                    //律师
                    CommonDialog.showLoginDialog(mContext, "暂未入驻，请立即前往入驻", "现在入驻，可立即开通线上法律咨询业务，拓展案源合作机会，让您获得可观的收益。", "我再考虑下", "去认证", new CommonDialog.CommonDialogCallback() {
                        @Override
                        public void onConfirmListener() {
                            Bundle bundle = new Bundle();
                            bundle.putString("authType", "1");
                            bundle.putInt("enterType", 1);
                            readyGo(mContext, thirdActivity, bundle);
                        }

                        @Override
                        public void onCancelListener() {

                        }
                    });
                }
                return false;
            }
        }
        return true;
    }

    public static void readyGo(Context context, Activity activity, Bundle bundle) {
        Intent intent = new Intent(context, activity.getClass());
        if (null != bundle) {
            intent.putExtras(bundle);
        }
        context.startActivity(intent);
    }
}
