package com.winhc.business;

import android.content.Context;
import android.content.pm.PackageInfo;
import android.content.pm.PackageManager;
import android.text.TextUtils;

import com.google.gson.reflect.TypeToken;
import com.winhc.business.utils.GsonUtils;
import com.winhc.widget.util.CollectionUtils;
import com.winhc.widget.util.SpUtil;

import java.lang.reflect.Type;
import java.util.ArrayList;
import java.util.List;

/**
 * Copyright: 2016 Joindata. All rights reserved.
 * author：===>>     panic     <===
 * Create Time:   ===>>  2017/11/1 11:14  <===
 * email：panic4java@gmail.com
 * describe:与业务相关的sharedpreferences
 * ********************************************************
 */
public class WinhcSharedPreferences {
    //第几次打开app
    public static final String KEY_START_TIME = "start_time";
    public static final String KEY_WX_UNIONID = "wx_unionId";
    public static final String KEY_WX_OPENID = "wx_openId";
    public static final String KEY_WX_NAME = "wx_name";
    public static final String KEY_WX_AVATAR = "wx_avatar";
    public static final String KEY_APP_CLEAR_COUNT = "key_app_clear_count";//清除sp数据的次数

    public static final String KEY_OSS_ACCESSKEY = "oss_accesskey";
    public static final String KEY_OSS_BUCKETNAME = "oss_bucketname";
    public static final String KEY_OSS_SECRETKEY = "oss_secretkey";
    public static final String KEY_OSS_ENDPOINT = "oss_endPoint";
    public static final String KEY_OSS_SECURITY_TOKEN = "oss_security_Token";

    public static final String KEY_APP_VERSION_INFO = "key_app_version_info";//app版本信息
    public static final String KEY_SECRET_PROTOCOL_DIALOG_OPEN_TIMES = "key_secret_protocol_dialog_open_times";//隐私政策弹框次数

    public static final String KEY_USER_LAWYER_CERTIFY = "key_user_lawyer_certify";//律师认证信息

    public static final String KEY_OPEN_RECOMMEND_COMPANY_TIME = "key_open_recommend_company_time";//app打开推荐企业次数

    public static final String KEY_LAWYER_DETAIL_TIPS = "key_lawyer_detail_tips";//app律师详情tips次数

    public static final String KEY_DEPOSIT_XUZHI_VALUE = "key_deposit_xuzhi_value";//旧案托管须知是否勾选

    public static final String KEY_INVITE_ACTIVITY_VALUE = "key_invite_activity_value";//邀请好友进入次数
    //用户选择的身份
    public static final String KEY_IDENTITY = "key_identity_value";

    public static final String KEY_LAWYER_WORK_NOTE_VALUE = "key_lawyer_work_note_value";//工作台随手记汇报功能开关

    public static final String KEY_REQUEST_ACTIVITY_VALUE = "key_request_activity_value";//请求活动时间

    public static final String KEY_DEBT_OPEN_COUNTS_VALUE = "key_debt_open_counts_value";//履债评估打开次数

    public static final String KEY_TRADE_OPEN_COUNTS_VALUE = "key_trade_open_counts_value";//交易评估打开次数

    public static final String KEY_CERTIFY_OPEN_VALUE = "key_certify_open_value";//律师是否在本地弹过入驻成功提醒框

    public static final String KEY_MINE_AMT_OPEN_VALUE = "key_mine_amt_open_value";//我的页面金额是否显示

    public static final String KEY_MINE_XFC_PERMISSION_OPEN_VALUE = "key_mine_xfc_permission_open_value";//悬浮窗权限弹框提示是否打开

    public static final String KEY_LBS_VALUE = "key_lbs_value";//位置信息(city)
    public static final String KEY_LBS_PROVINCE_VALUE = "key_lbs_province_value";//位置信息(province)
    public static final String KEY_LBS_CODE_VALUE = "key_lbs_code_value";//位置编码信息

    public static final String KEY_SECRET_POINT_VALUE = "key_secret_point_value";//隐私政策复选框是否选中

    public static final String KEY_IDENTITY_PANEL_VALUE = "key_identity_panel_value";//首页是否弹出身份切换面板

    public static final String KEY_LAWYER_VIDEO_TIPS_VALUE = "key_lawyer_video_tips_value";//律师庭审视频tips是否弹出

    public static final String KEY_ASSETS_DB_INIT_VALUE = "key_assets_db_init_value";//是否读取了db文件

    public static final String KEY_UPDATE_DB_TIME_VALUE = "key_update_db_time_value";//更新db文件的时间

    public static final String KEY_NEW_USER_BAG_VALUE = "key_new_user_bag_value";//新人礼包次数
    public static final String WX_BIND_DATE = "wx_bind_date";//微信绑定的日期 每天只有一次
    public static final String FREE_QA_DATE = "free_qa_date";//免费咨询只谈一次


    public static final String KEY_LOCAL_USER_INFO = "localUserInfo";

    public static final String CONFIG_FILE = "WinhcLocalConfig"; // 配置信息句柄
    public static String appChannel = "guanwang";
    public static int versionCode = 1;
    public static String versionName = "1.0.0";

    static class Holder {
        static WinhcSharedPreferences preferences = new WinhcSharedPreferences();
    }

    static SpUtil spUtil;

    public WinhcSharedPreferences() {
    }

    public static void init(Context context) {
        spUtil = new SpUtil(context, CONFIG_FILE);
        initAppInfo(context);
    }

    public static int getVersionCode() {
        return versionCode;
    }

    public static String getVersionName() {
        return versionName;
    }

    public static void setAppChannel(String channel) {
        appChannel = channel;
    }

    public static String getAppChannel() {
        return appChannel;
    }

    public static void initAppInfo(Context context) {
        try {
            PackageInfo packageInfo = context.getPackageManager().getPackageInfo(context.getPackageName(), 0);
            versionCode = packageInfo.versionCode;
            versionName = packageInfo.versionName;
        } catch (PackageManager.NameNotFoundException e) {
            e.printStackTrace();
        }
    }

    public static void setIdentityPanelValue(boolean value) {
        if (spUtil == null) {
            return;
        }
        spUtil.put(KEY_IDENTITY_PANEL_VALUE, value);
    }

    public static boolean getIdentityPanelValue() {
        if (spUtil == null) {
            return false;
        }
        return spUtil.getBoolean(KEY_IDENTITY_PANEL_VALUE, false);
    }

    public static void setKeyMineXfcPermissionOpenValue(boolean value) {
        if (spUtil == null) {
            return;
        }
        spUtil.put(KEY_MINE_XFC_PERMISSION_OPEN_VALUE, value);
    }

    public static boolean getKeyMineXfcPermissionOpenValue() {
        if (spUtil == null) {
            return false;
        }
        return spUtil.getBoolean(KEY_MINE_XFC_PERMISSION_OPEN_VALUE, false);
    }

    public static void setKeyMineAmtOpenValue(boolean value) {
        if (spUtil == null) {
            return;
        }
        spUtil.put(KEY_MINE_AMT_OPEN_VALUE, value);
    }

    public static boolean getKeyMineAmtOpenValue() {
        if (spUtil == null) {
            return false;
        }
        return spUtil.getBoolean(KEY_MINE_AMT_OPEN_VALUE, true);
    }

    public static void setKeyCertifyOpenValue(int value) {
        if (spUtil == null) {
            return;
        }
        spUtil.put(KEY_CERTIFY_OPEN_VALUE, value);
    }

    public static int getKeyCertifyOpenValue() {
        if (spUtil == null) {
            return 0;
        }
        return spUtil.getInt(KEY_CERTIFY_OPEN_VALUE, 0);
    }

    public static void setKeyTradeOpenCountsValue(int value) {
        if (spUtil == null) {
            return;
        }
        spUtil.put(KEY_TRADE_OPEN_COUNTS_VALUE, value);
    }

    public static int getKeyTradeOpenCountsValue() {
        if (spUtil == null) {
            return 0;
        }
        return spUtil.getInt(KEY_TRADE_OPEN_COUNTS_VALUE, 0);
    }

    public static void setKeyDebtOpenCountsValue(int value) {
        if (spUtil == null) {
            return;
        }
        spUtil.put(KEY_DEBT_OPEN_COUNTS_VALUE, value);
    }

    public static int getKeyDebtOpenCountsValue() {
        if (spUtil == null) {
            return 0;
        }
        return spUtil.getInt(KEY_DEBT_OPEN_COUNTS_VALUE, 0);
    }

    public static void setKeyWorkNoteValue(boolean value) {
        if (spUtil == null) {
            return;
        }
        spUtil.put(KEY_LAWYER_WORK_NOTE_VALUE, value);
    }

    public static boolean getKeyWorkNoteValue() {
        if (spUtil == null) {
            return true;
        }
        return spUtil.getBoolean(KEY_LAWYER_WORK_NOTE_VALUE, true);
    }

    /**
     * 增加次数
     */
    public static void addInviteTimes() {
        int times = getInviteTimes();
        if (spUtil == null) {
            return;
        }
        spUtil.put(KEY_INVITE_ACTIVITY_VALUE, times + 1);
    }

    /**
     * 获取次数
     *
     * @return
     */
    public static int getInviteTimes() {
        if (spUtil == null) {
            return 0;
        }
        return spUtil.getInt(KEY_INVITE_ACTIVITY_VALUE, 0);
    }

    /**
     * 增加打开次数
     */
    public static void addTipsTimes() {
        int times = getTipsTimes();
        if (spUtil == null) {
            return;
        }
        spUtil.put(KEY_LAWYER_DETAIL_TIPS, times + 1);
    }

    /**
     * 获取打开次数
     *
     * @return
     */
    public static int getTipsTimes() {
        if (spUtil == null) {
            return 0;
        }
        return spUtil.getInt(KEY_LAWYER_DETAIL_TIPS, 0);
    }

    /**
     * 增加打开次数
     */
    public static void addRecommendTimes() {
        int times = getRecommendTimes();
        if (spUtil == null) {
            return;
        }
        spUtil.put(KEY_OPEN_RECOMMEND_COMPANY_TIME, times + 1);
    }

    /**
     * 获取打开次数
     *
     * @return
     */
    public static int getRecommendTimes() {
        if (spUtil == null) {
            return 0;
        }
        return spUtil.getInt(KEY_OPEN_RECOMMEND_COMPANY_TIME, 0);
    }

    /**
     * 增加打开次数
     */
    public static void addStartTimes() {
        int times = getStartTimes();
        if (spUtil == null) {
            return;
        }
        spUtil.put(KEY_START_TIME, times + 1);
    }

    /**
     * 获取打开次数
     *
     * @return
     */
    public static int getStartTimes() {
        if (spUtil == null) {
            return 0;
        }
        return spUtil.getInt(KEY_START_TIME, 0);
    }

    /**
     * 增加打开次数
     */
    public static void addOpenDialogTimes() {
        int times = getOpenDialogTimes();
        if (spUtil == null) {
            return;
        }
        spUtil.put(KEY_SECRET_PROTOCOL_DIALOG_OPEN_TIMES, times + 1);
    }

    /**
     * 获取打开次数
     *
     * @return
     */
    public static int getOpenDialogTimes() {
        if (spUtil == null) {
            return 0;
        }
        return spUtil.getInt(KEY_SECRET_PROTOCOL_DIALOG_OPEN_TIMES, 0);
    }

    /**
     * 清除打开次数
     */
    public static void clearStartTimes() {
        if (spUtil != null) {
            spUtil.put(KEY_START_TIME, 0);
        }
    }

    public static void addClearTimes() {
        int times = getClearTimes();
        if (spUtil == null) {
            return;
        }
        spUtil.put(KEY_APP_CLEAR_COUNT, times + 1);
    }

    /**
     * 获取打开次数
     *
     * @return
     */
    public static int getClearTimes() {
        if (spUtil == null) {
            return 0;
        }
        return spUtil.getInt(KEY_APP_CLEAR_COUNT, 0);
    }

    /**
     * 清除打开次数
     */
    public static void clearClearTimes() {
        if (spUtil == null) {
            return;
        }
        spUtil.put(KEY_APP_CLEAR_COUNT, 0);
    }

    public static void setKeyWxOpenid(String openId) {
        if (spUtil != null) {
            spUtil.put(KEY_WX_OPENID, openId);
        }
    }

    public static String getKeyWxOpenid() {
        if (spUtil == null) {
            return "";
        }
        return spUtil.getString(KEY_WX_OPENID, "");
    }

    public static void clearKeyWxOpenid() {
        if (spUtil != null) {
            spUtil.put(KEY_WX_OPENID, "");
        }
    }

    public static void setKeyWxUnionid(String unionId) {
        if (spUtil != null) {
            spUtil.put(KEY_WX_UNIONID, unionId);
        }
    }

    public static String getKeyWxUnionid() {
        if (spUtil == null) {
            return "";
        }
        return spUtil.getString(KEY_WX_UNIONID, "");
    }

    public static void clearKeyWxUnionid() {
        if (spUtil != null) {
            spUtil.put(KEY_WX_UNIONID, "");
        }
    }

    public static void setKeyWxName(String name) {
        if (spUtil != null) {
            spUtil.put(KEY_WX_NAME, name);
        }
    }

    public static String getKeyWxName() {
        if (spUtil == null) {
            return "";
        }
        return spUtil.getString(KEY_WX_NAME, "");
    }

    public static void clearKeyWxName() {
        if (spUtil != null) {
            spUtil.put(KEY_WX_NAME, "");
        }
    }

    public static void setKeyWxAvatar(String avatar) {
        if (spUtil != null) {
            spUtil.put(KEY_WX_AVATAR, avatar);
        }
    }

    public static String getKeyWxAvatar() {
        if (spUtil == null) {
            return "";
        }
        return spUtil.getString(KEY_WX_AVATAR, "");
    }

    public static void clearKeyWxAvatar() {
        if (spUtil != null) {
            spUtil.put(KEY_WX_AVATAR, "");
        }
    }

    /**
     * 存阿里OSS ACCESSKEY
     */
    public static void setOssAccessKey(String accessKey) {
        if (spUtil != null) {
            spUtil.put(KEY_OSS_ACCESSKEY, accessKey);
        }
    }

    /**
     * 取阿里OSS ACCESSKEY
     */
    public static String getOssAccessKey() {
        if (spUtil == null) {
            return "";
        }
        return spUtil.getString(KEY_OSS_ACCESSKEY, "");
    }

    /**
     * 清除阿里OSS ACCESSKEY
     */
    public static void clearOssAccessKey() {
        if (spUtil != null) {
            spUtil.put(KEY_OSS_ACCESSKEY, "");
        }
    }

    /**
     * 存阿里OSS buckekName
     */
    public static void setOssBuckekName(String buckekName) {
        if (spUtil != null) {
            spUtil.put(KEY_OSS_BUCKETNAME, buckekName);
        }
    }

    /**
     * 取阿里OSS buckekName
     */
    public static String getOssBuckekName() {
        if (spUtil == null) {
            return "";
        }
        return spUtil.getString(KEY_OSS_BUCKETNAME, "");
    }

    /**
     * 清除阿里OSS buckekName
     */
    public static void clearOssBuckekName() {
        if (spUtil != null) {
            spUtil.put(KEY_OSS_BUCKETNAME, "");
        }
    }

    /**
     * 存阿里OSS ScrectKey
     */
    public static void setOssScrectKey(String secretkey) {
        if (spUtil != null) {
            spUtil.put(KEY_OSS_SECRETKEY, secretkey);
        }
    }

    /**
     * 取阿里OSS ScrectKey
     */
    public static String getOssScrectKey() {
        if (spUtil == null) {
            return "";
        }
        return spUtil.getString(KEY_OSS_SECRETKEY, "");
    }

    /**
     * 清除阿里OSS ScrectKey
     */
    public static void clearOssScrectKey() {
        if (spUtil != null) {
            spUtil.put(KEY_OSS_SECRETKEY, "");
        }
    }


    /**
     * 存阿里OSS ossEndpoint
     */
    public static void setKeyOssEndpoint(String ossEndpoint) {
        if (spUtil != null) {
            spUtil.put(KEY_OSS_ENDPOINT, ossEndpoint);
        }
    }

    /**
     * 取阿里OSS ossEndpoint
     */
    public static String getKeyOssEndpoint() {
        if (spUtil == null) {
            return "";
        }
        return spUtil.getString(KEY_OSS_ENDPOINT, "");
    }

    /**
     * 存阿里OSS OssSecurityToken
     */
    public static void setKeyOssSecurityToken(String keyOssSecurityToken) {
        if (spUtil != null) {
            spUtil.put(KEY_OSS_SECURITY_TOKEN, keyOssSecurityToken);
        }
    }

    /**
     * 取阿里OSS OssSecurityToken
     */
    public static String getKeyOssSecurityToken() {
        if (spUtil == null) {
            return "";
        }
        return spUtil.getString(KEY_OSS_SECURITY_TOKEN, "");
    }


    /**
     * 保存List
     *
     * @param tag
     * @param datalist
     */
    public static <T> void setDataList(String tag, List<T> datalist) {
        if (spUtil != null) {
            if (CollectionUtils.isEmpty(datalist)) {//清空数据
                spUtil.put(tag, "", true);
                return;
            }
            //转换成json数据，再保存
            String json = GsonUtils.getGson().toJson(datalist);
            spUtil.put(tag, json, true);
        }
    }

    public static boolean getBoolean(String key, boolean defVal) {
        if (spUtil == null) {
            return defVal;
        }
        return spUtil.getBoolean(key, defVal);
    }

    public static String getString(String key, String defVal) {
        if (spUtil == null) {
            return "";
        }
        return spUtil.getString(key, defVal);
    }

    /**
     * 共享数据中存储bean对象
     *
     * @param key
     * @param bean
     */
    public static void saveBean(String key, Object bean) {
        if (spUtil != null) {
            //转换成json数据，再保存
            String json = GsonUtils.getGson().toJson(bean);
            spUtil.put(key, json, false);
        }
    }

    /**
     * 共享数据中获取bean对象
     *
     * @param key
     * @param typeOfT 想要转成的bean对象类型
     * @return
     */
    public static <T> T getBean(String key, Type typeOfT) {
        if (spUtil != null) {
            String strJson = spUtil.getString(key, "");
            if (null == strJson || TextUtils.isEmpty(strJson)) {
                return null;
            }
            //转换成json数据，再保存
            return GsonUtils.getGson().fromJson(strJson, typeOfT);
        }
        return null;
    }

    public static <T> ArrayList<T> getDataList(String tag) {
        ArrayList<T> datalist = new ArrayList<T>();
        if (spUtil != null) {
            String strJson = spUtil.getString(tag, "");
            if (null == strJson || TextUtils.isEmpty(strJson)) {
                return datalist;
            }
            //转换成json数据，再保存
            datalist = GsonUtils.getGson().fromJson(strJson, new TypeToken<List<String>>() {
            }.getType());
        }
        return datalist;
    }

    public static <T> ArrayList<T> getDataList(String tag, Type typeOfT) {
        ArrayList<T> datalist = new ArrayList<T>();
        if (spUtil != null) {
            String strJson = spUtil.getString(tag, "");
            if (null == strJson || TextUtils.isEmpty(strJson)) {
                return datalist;
            }
            //转换成json数据，再保存
            datalist = GsonUtils.getGson().fromJson(strJson, typeOfT);
        }
        return datalist;
    }

    /**
     * 清除指定key的数据
     *
     * @param keys
     */
    public static void resetByKey(String... keys) {
        if (spUtil != null) {
            spUtil.remove(keys);
        }
    }
}
