package com.winhc.business.builder;

import android.content.Context;
import android.view.WindowManager;

import com.winhc.business.widget.progresshud.KProgressHUD;
import com.winhc.widget.util.MMLog;

public class KProgressHudUtil {
    public static KProgressHUD hud;
    public static KProgressHUD polling;//轮询时的dialog

    /**
     * 加载网络请求时用的dialog类型
     *
     * @param context
     */
    public static void showNetWorkLoading(Context context) {
        try {
            showProgressDialog(context, KProgressHUD.Style.SPIN_INDETERMINATE, "正在加载中...", null, false);
        } catch (Exception e) {
            MMLog.e(e.getMessage());
        }
    }

    public static void showPollingLoading(Context context, String content) {
        try {
            showPollingDialog(context, KProgressHUD.Style.SPIN_INDETERMINATE, content, null, true);
        } catch (Exception e) {
            MMLog.e(e.getMessage());
        }
    }

    /**
     * @param context
     * @param style   SPIN_INDETERMINATE, PIE_DETERMINATE, ANNULAR_DETERMINATE, BAR_DETERMINATE
     * @param label   标题
     * @param detail  内容
     */
    public static void showProgressDialog(Context context, KProgressHUD.Style style, String label, String detail) throws WindowManager.BadTokenException {
        showProgressDialog(context, style, label, detail, true);
    }

    public static void showProgressDialog(Context context, KProgressHUD.Style style, String label, String detail, boolean isCancel) throws WindowManager.BadTokenException {

        if (hud == null) {
            hud = KProgressHUD.create(context)
                    .setStyle(style)
                    .setLabel(label)
                    .setDetailsLabel(detail)
                    .setCancellable(isCancel).show();
        } else {
            hud.dismiss();
            hud = null;
            hud = KProgressHUD.create(context)
                    .setStyle(style)
                    .setLabel(label)
                    .setDetailsLabel(detail)
                    .setCancellable(isCancel).show();
        }
    }

    public static void showPollingDialog(Context context, KProgressHUD.Style style, String label, String detail, boolean isCancel) throws WindowManager.BadTokenException {

        if (polling == null) {
            polling = KProgressHUD.create(context)
                    .setStyle(style)
                    .setLabel(label)
                    .setDetailsLabel(detail)
                    .setCancellable(isCancel).show();
        } else {
            polling.dismiss();
            polling = null;
            polling = KProgressHUD.create(context)
                    .setStyle(style)
                    .setLabel(label)
                    .setDetailsLabel(detail)
                    .setCancellable(isCancel).show();
        }
    }

    public static void showDeterminateProgress(Context context, long maxProgress) throws WindowManager.BadTokenException {

        if (hud == null) {
            hud = KProgressHUD.create(context)
                    .setStyle(KProgressHUD.Style.PIE_DETERMINATE)
                    .setLabel("下载中")
                    .setSize(160, 160)
                    .setMaxProgress(maxProgress)
                    .setCancellable(false).show();
        } else {
            hud.dismiss();
            hud = null;
            hud = KProgressHUD.create(context)
                    .setStyle(KProgressHUD.Style.PIE_DETERMINATE)
                    .setLabel("下载中")
                    .setMaxProgress(maxProgress)
                    .setCancellable(false).show();
        }
    }

    public static void dismissProgressDialog() {
        if (null != hud && hud.isShowing()) {
            hud.dismiss();
            hud = null;
        }
    }

    public static void dismissPollingDialog() {
        if (null != polling && polling.isShowing()) {
            polling.dismiss();
            polling = null;
        }
    }
}
