package com.winhc.business.model;

/**
 * Create by LZ at 2021/9/15
 * 通用的消息对象
 */
public class EventMessage<T> {
    /**
     * 1 IM中的消息支付结束
     * 2 找律师 条件点击 上滑AppBarLayout
     * 3 IM中律师重新下单 更新顶部布局
     * 4 图文、电话咨询结束服务，刷新详情页面
     * 5 跳转首页消息列表fragment
     */
    private int code;
    private String message;
    private T data;


    public EventMessage(int code) {
        this.code = code;
    }

    public EventMessage(String message) {
        this.message = message;
    }

    public EventMessage(int code, String message) {
        this.code = code;
        this.message = message;
    }

    public EventMessage(int code, String message, T data) {
        this.code = code;
        this.message = message;
        this.data = data;
    }

    public int getCode() {
        return code;
    }

    public void setCode(int code) {
        this.code = code;
    }

    public String getMessage() {
        return message;
    }

    public void setMessage(String message) {
        this.message = message;
    }

    public T getData() {
        return data;
    }

    public void setData(T data) {
        this.data = data;
    }
}
