package com.winhc.business.net;

import android.text.TextUtils;

import com.winhc.business.AccountManager;
import com.winhc.business.WinhcSetting;
import com.winhc.business.utils.DeviceUtil;
import com.winhc.business.utils.GsonUtils;

import java.io.IOException;

import okhttp3.Interceptor;
import okhttp3.Request;
import okhttp3.Response;

/**
 * Create by LZ at 2021/9/2
 */
public class AppHeaderInterceptor implements Interceptor {
    public static final String KEY_OS = "osType"; //系统类型
    public static final String KEY_DEVICE_ID = "deviceId";
    public static final String KEY_OS_BRAND = "brand";
    public static final String KEY_APP_VERSION = "appVersion";
    public static final String KEY_API_VERSION = "apiVersion";
    public static final String KEY_OS_VERSION = "osVersion";
    public static final String KEY_APP_ID = "appid";
    public static final String KEY_SESSION_ID = "sessionId";
    public static final String KEY_APP_CHANNEL = "AppChannel";
    public static final String KEY_APP_ACY_NAME = "currentAcyName";
    public static final String KEY_APP_VOURCHER_LIST = "vourcherList";
    public static final String KEY_APP_PACKAGE = "package";

    @Override
    public Response intercept(Chain chain) throws IOException {
        Request request = chain.request();
        //请求头,具体参数与后台商议
        Request newReq =
                request.newBuilder()
                        .addHeader("content-type", "application/json;charset:utf-8")
                        .addHeader(KEY_OS, "android")
                        .addHeader(KEY_APP_ID, "app")
                        .addHeader(KEY_APP_PACKAGE, "com.winhc.user.app")
                        .addHeader(KEY_SESSION_ID, TextUtils.isEmpty(AccountManager.getInstance().getSessionId()) ?
                                "" : AccountManager.getInstance().getSessionId())
                        .addHeader(KEY_DEVICE_ID, DeviceUtil.getUniquePsuedoID())
                        .addHeader(KEY_APP_VERSION, WinhcSetting.getVersionName())
                        .addHeader(KEY_OS_BRAND, WinhcSetting.getOsBrand())
                        .addHeader(KEY_API_VERSION, "1.0")
                        .addHeader(KEY_OS_VERSION, WinhcSetting.getOsVersion())
                        .addHeader(KEY_APP_CHANNEL, WinhcSetting.getAppChannel())
                        .addHeader(KEY_APP_ACY_NAME, WinhcSetting.getCurrentAcyName())
                        .addHeader(KEY_APP_VOURCHER_LIST, GsonUtils.getGson().toJson(WinhcSetting.getTiYanQuanList()))
                        .build();
        return chain.proceed(newReq);
    }
}
