package com.youth.banner.transformer;

import android.support.v4.view.ViewPager;
import android.view.View;

/**
 * 3D效果
* Created by toby on 2019/5/9.
*/

public class ZoomPageTransformer implements ViewPager.PageTransformer {

//    private static final float MAX_SCALE = 1.0f;//0缩放
//
//    private static final float MIN_SCALE = 0.85f;//0.85缩放
//
//    private float MIN_ALPHA = 1.0f;//最小透明度
//
//    public ZoomPageTransformer() {
//    }
//    public ZoomPageTransformer(float MIN_ALPHA) {
//        this.MIN_ALPHA = MIN_ALPHA;
//    }
//    @Override
//    public void transformPage(View view, float position) {
//        //setScaleY只支持api11以上
//        /**
//         * (-oo,-1) 相对于左边第一页，其左边的所有页面 **
//         * x、y拉伸为MIN_SCALE、透明度MIN_ALPHA
//         */
//        if (position < -1) {
//            view.setScaleX(MIN_SCALE);
//            view.setScaleY(MIN_SCALE);
//            view.setAlpha(MIN_ALPHA);
//        }
//        /**
//         * [-1, 1 )当前页的左右第一页
//         */
//        else if (position < 1) {
//            float scaleFactor = MIN_SCALE + (1 - Math.abs(position)) * (MAX_SCALE - MIN_SCALE);
//            //[0, 1 ） 相对于当前选中页，其右边第一页 **
//            if (position > 0) {
//                view.setTranslationX(-scaleFactor);
//            }
//            // [-1, 0 ) 相对于当前选中页，其左边的第一页**
//            else if (position < 0) {
//                view.setTranslationX(scaleFactor);
//            }
//            view.setScaleY(scaleFactor);
//            view.setScaleX(scaleFactor);
//
//            // float alpha = 1f -  Math.abs(position) * (1 - );
//
//            float alpha = MIN_ALPHA + (1 - MIN_ALPHA) * (1 - Math.abs(position));
//            view.setAlpha(alpha);
//
//        }
//        /**
//         * [1,+oo） 相对于右边第一页，其右边的所有页面
//         * x、y拉伸为MIN_SCALE、透明度MIN_ALPHA
//         */
//        else { // (1,+Infinity]
//            view.setScaleX(MIN_SCALE);
//            view.setScaleY(MIN_SCALE);
//            view.setAlpha(MIN_ALPHA);
//        }
//    }

    private static final float MIN_SCALE = 0.9f;
    private static final float MIN_ALPHA = 0.5f;

    private static float defaultScale = 0.9f;

    @Override
    public void transformPage(View view, float position) {
        int pageWidth = view.getWidth();
        int pageHeight = view.getHeight();

        if (position < -1) { // [-Infinity,-1)
            // This page is way off-screen to the left.
            view.setAlpha(0);
            view.setScaleX(defaultScale);
            view.setScaleY(defaultScale);
        } else if (position <= 1) { // [-1,1]
            // Modify the default slide transition to shrink the page as well
            float scaleFactor = Math.max(MIN_SCALE, 1 - Math.abs(position));
            float vertMargin = pageHeight * (1 - scaleFactor) / 2;
            float horzMargin = pageWidth * (1 - scaleFactor) / 2;
            if (position < 0) {
                view.setTranslationX(horzMargin - vertMargin / 2);
            } else {
                view.setTranslationX(-horzMargin + vertMargin / 2);
            }

            // Scale the page down (between MIN_SCALE and 1)
            view.setScaleX(scaleFactor);
            view.setScaleY(scaleFactor);

            // Fade the page relative to its size.
            view.setAlpha(MIN_ALPHA +
                    (scaleFactor - MIN_SCALE) /
                            (1 - MIN_SCALE) * (1 - MIN_ALPHA));

        } else { // (1,+Infinity]
            // This page is way off-screen to the right.
            view.setAlpha(0);
            view.setScaleX(defaultScale);
            view.setScaleY(defaultScale);
        }
    }
}
